﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace DocumentFormat.OpenXml.Lite.Core.ContentType
{
    public enum ContentType
    {
        [Description("application/xml")]
        Xml,
        [Description("application/vnd.openxmlformats-package.relationships+xml")]
        Rels,
        [Description("application/vnd.openxmlformats-officedocument.extended-properties+xml")]
        App,
        [Description("application/vnd.openxmlformats-package.core-properties+xml")]
        Core,
        [Description("application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml")]
        OfficeWord,
        [Description("application/vnd.openxmlformats-officedocument.drawing+xml")]
        OfficeDrawing,
        [Description("application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml")]
        WordStyle,
        [Description("application/vnd.openxmlformats-officedocument.wordprocessingml.header+xml")]
        WordHeader,
        [Description("application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml")]
        WordFooter,
        [Description("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml")]
        Spreadsheet,
        [Description("application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml")]
        Worksheet,
        [Description("application/vnd.openxmlformats-officedocument.spreadsheetml.sharedStrings+xml")]
        SharedStrings,
        [Description("application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml")]
        SmlTable,
        [Description("application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml")]
        SmlStyle,
        [Description("application/vnd.openxmlformats-officedocument.drawingml.chart+xml")]
        Chart,
        [Description("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet")]
        Sheet,
        [Description("application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml")]
        Presentation,
        [Description("application/vnd.openxmlformats-officedocument.presentationml.slideMaster+xml")]
        SlideMaster,
        [Description("application/vnd.openxmlformats-officedocument.presentationml.slide+xml")]
        Slide,
        [Description("application/vnd.openxmlformats-officedocument.presentationml.slideLayout+xml")]
        SlideLayout,
        [Description("application/vnd.openxmlformats-officedocument.theme+xml")]
        Theme
    }
}
