﻿using DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties;
using DocumentFormat.OpenXml.Lite.DrawingML.Types;
using DocumentFormat.OpenXml.Lite.Shared;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Chart.Elements
{
    [XmlRoot("marker", Namespace = Constants.Chart)]
    public class Marker : XmlSerializable
    {
        [Optional]
        [XmlElement("symbol", Namespace = Constants.Chart)]
        public RequiredValue<ST_MarkerStyle> Symbol { get; set; }

        [Optional]
        [XmlElement("size", Namespace = Constants.Chart)]
        public NullableValue<byte> Size { get; set; }

        [Optional]
        [XmlElement("spPr", Namespace = Constants.Chart)]
        public ShapeProperties ShapeProperties { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Chart)]
        public ExtensionList ExtensionList { get; set; }

        public Marker() { }
    }
}
