﻿using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Color
{
    [XmlRoot("clrMap", Namespace = Constants.Main)]
    public class ColorSchemeMap : XmlSerializable
    {
        [XmlAttribute("bg1", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Background1 { get; set; }

        [XmlAttribute("tx1", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Text1 { get; set; }

        [XmlAttribute("bg2", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Background2 { get; set; }

        [XmlAttribute("tx2", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Text2 { get; set; }

        [XmlAttribute("accent1", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Accent1 { get; set; }

        [XmlAttribute("accent2", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Accent2 { get; set; }

        [XmlAttribute("accent3", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Accent3 { get; set; }

        [XmlAttribute("accent4", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Accent4 { get; set; }

        [XmlAttribute("accent5", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Accent5 { get; set; }

        [XmlAttribute("accent6", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Accent6 { get; set; }

        [XmlAttribute("hlink", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex Hyperlink { get; set; }

        [XmlAttribute("folHlink", Form = XmlSchemaForm.Qualified)]
        public ST_ColorSchemeIndex FollowedHyperlink { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public ColorSchemeMap() { }
    }
}
