﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DocumentFormat.OpenXml.Lite.DrawingML
{
    public class Constants
    {
        public const string Xml = "http://www.w3.org/XML/1998/namespace";
        public const string Main = "http://schemas.openxmlformats.org/drawingml/2006/main";
        public const string Chart = "http://schemas.openxmlformats.org/drawingml/2006/chart";
        public const string Picture = "http://schemas.openxmlformats.org/drawingml/2006/picture";
        public const string Relationship = "http://schemas.openxmlformats.org/officeDocument/2006/relationships";

        public static string GetDefaultPrefix(string ns)
        {
            switch (ns)
            {
                case Xml: return "xml";
                case Main: return "a";
                case Chart: return "c";
                case Picture: return "pic";
                case Relationship: return "r";
                default: break;
            }
            return string.Empty;
        }
    }
}
