﻿using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Font
{
    [XmlRoot("", Namespace = Constants.Main)]
    public class FontElement : XmlSerializable
    {
        [XmlElement("latin", Namespace = Constants.Main)]
        public Font Latin { get; set; }

        [XmlElement("ea", Namespace = Constants.Main)]
        public Font EastAsian { get; set; }

        [XmlElement("cs", Namespace = Constants.Main)]
        public Font ComplexScript { get; set; }

        [Optional]
        [XmlElement("font", Namespace = Constants.Main)]
        public XmlList<SimpleFont> Fonts { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public FontElement() 
        {
            Fonts = new XmlList<SimpleFont>();
        }
    }
}
