﻿using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Locks
{
    [XmlRoot("graphicFrameLocks", Namespace = Constants.Main)]
    public class GraphicFrameLocks : XmlSerializable
    {
        [Optional]
        [XmlAttribute("noGrp", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> DisallowShapeGrouping { get; set; }

        [Optional]
        [XmlAttribute("noDrilldown", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> DisallowSelectionOfChildShapes { get; set; }

        [Optional]
        [XmlAttribute("noSelect", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> DisallowShapeSelection { get; set; }

        [Optional]
        [XmlAttribute("noChangeAspect", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> DisallowAspectRationChanging { get; set; }

        [Optional]
        [XmlAttribute("noMove", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> DisallowShapeMoving { get; set; }

        [Optional]
        [XmlAttribute("noResize", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> DisallowShapeResizing { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public GraphicFrameLocks() { }
    }
}
