﻿using DocumentFormat.OpenXml.Lite.Core.Interfaces;
using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties;
using DocumentFormat.OpenXml.Lite.DrawingML.Text;
using DocumentFormat.OpenXml.Lite.DrawingML.Visual;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Geometry
{
    [XmlRoot("pic", Namespace = Constants.Main)]
    public class Picture : XmlSerializable, IGroupShape
    {
        [Optional]
        [XmlAttribute("macro", Form = XmlSchemaForm.Qualified)]
        public string CustomFunctionReference { get; set; }

        [Optional]
        [XmlAttribute("fPublished", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> PublishToServer { get; set; }

        [XmlElement("nvPicPr", Namespace = Constants.Main)]
        public NonVisualPictureProperties NonVisualProperties { get; set; }

        [XmlElement("blipFill", Namespace = Constants.Main)]
        public BlipFill BlipFill { get; set; }

        [XmlElement("spPr", Namespace = Constants.Main)]
        public ShapeProperties ShapeProperties { get; set; }

        [Optional]
        [XmlElement("style", Namespace = Constants.Main)]
        public Color.Style Style { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public Picture() { }
    }
}
