﻿using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Text;
using DocumentFormat.OpenXml.Lite.DrawingML.Transformation;
using DocumentFormat.OpenXml.Lite.DrawingML.Types;
using DocumentFormat.OpenXml.Lite.DrawingML.Visual;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties
{
    [XmlRoot("grpSpPr", Namespace = Constants.Main)]
    public class GroupShapeProperties : XmlSerializable
    {
        [Optional]
        [XmlAttribute("bwMode", Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_BlackWhiteMode> BlackWhiteMode { get; set; }

        [Optional]
        [XmlElement("xfrm", Namespace = Constants.Main)]
        public GroupTransform2d Transform2d { get; set; }

        [Optional]
        [XmlElement("", Namespace = Constants.Main)]
        public IFillProperty FillProperty { get; set; }

        [Optional]
        [XmlElement("", Namespace = Constants.Main)]
        public IEffectProperty EffectProperty { get; set; }

        [Optional]
        [XmlElement("scene3d", Namespace = Constants.Main)]
        public Scene3dProperties Properties3d { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public GroupShapeProperties() { }
    }
}
