﻿using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Text;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties
{
    [XmlRoot("cNvPr", Namespace = Constants.Main)]
    public class NonVisualProperties : XmlSerializable
    {
        [XmlAttribute("id", Form = XmlSchemaForm.Qualified)]
        public uint Id { get; set; }

        [XmlAttribute("name", Form = XmlSchemaForm.Qualified)]
        public string Name { get; set; }

        [Optional]
        [XmlAttribute("descr", Form = XmlSchemaForm.Qualified)]
        public string Description { get; set; }

        [Optional]
        [XmlAttribute("hidden", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> Hidden { get; set; }

        [Optional]
        [XmlElement("hlinkClick", Namespace = Constants.Main)]
        public Hyperlink HyperlinkClick { get; set; }

        [Optional]
        [XmlElement("hlinkOver", Namespace = Constants.Main)]
        public Hyperlink HyperlinkHover { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public NonVisualProperties() { }
    }
}
