﻿using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Text;
using DocumentFormat.OpenXml.Lite.DrawingML.Transformation;
using DocumentFormat.OpenXml.Lite.DrawingML.Visual;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties
{
    [XmlRoot("spPr", Namespace = Constants.Main)]
    public class ShapeProperties : XmlSerializable
    {
        [Optional]
        [XmlElement("xfrm", Namespace = Constants.Main)]
        public Transform2d Transform2d { get; set; }

        [Optional]
        [XmlElement("", Namespace = Constants.Main)]
        public IGeometry Geometry { get; set; }

        [Optional]
        [XmlElement("", Namespace = Constants.Main)]
        public IFillProperty FillProperty { get; set; }

        [Optional]
        [XmlElement("ln", Namespace = Constants.Main)]
        public Line Line { get; set; }

        [Optional]
        [XmlElement("", Namespace = Constants.Main)]
        public IEffectProperty EffectProperty { get; set; }

        [Optional]
        [XmlElement("scene3d", Namespace = Constants.Main)]
        public Scene3dProperties Scene3dProperties { get; set; }

        [Optional]
        [XmlElement("sp3d", Namespace = Constants.Main)]
        public Shape2d Sp3d { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public ShapeProperties() { }
    }
}
