﻿using DocumentFormat.OpenXml.Lite.DrawingML.Transformation;
using DocumentFormat.OpenXml.Lite.DrawingML.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Visual
{
    [XmlRoot("camera", Namespace = Constants.Main)]
    public class Camera : XmlSerializable
    {
        [XmlAttribute("prst", Form = XmlSchemaForm.Qualified)]
        public ST_PresetCameraType PresetCameraType { get; set; }

        [Optional]
        [XmlAttribute("fov", Form = XmlSchemaForm.Qualified)]
        public Nullable<int> FieldOfView { get; set; }

        [Optional]
        [XmlAttribute("zoom", Form = XmlSchemaForm.Qualified)]
        public Nullable<int> Zoom { get; set; }

        [Optional]
        [XmlElement("rot", Namespace = Constants.Main)]
        public XmlList<Rotation> Rotations { get; set; }

        public Camera() 
        {
            Rotations = new XmlList<Rotation>();
        }
    }
}
