﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Geometry;
using DocumentFormat.OpenXml.Lite.DrawingML.Transformation;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Drawing
{
    [XmlRoot("graphicFrame", Namespace = Constants.Presentation)]
    public class GraphicFrame : XmlSerializable, IShapeElement
    {
        [XmlElement("nvGraphicFramePr", Namespace = Constants.Presentation)]
        public NonVisualGraphicFrameProperties NonVisualGraphicFrameProperties { get; set; }

        [XmlElement("xfrm", Namespace = Constants.Presentation)]
        public Transform2d Transform2d { get; set; }

        [XmlElement("graphic", Namespace = Constants.Graphic)]
        public Graphic Graphic { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Presentation)]
        public ExtensionList ExtensionList { get; set; }

        public GraphicFrame() { }
    }
}
