﻿using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Base;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Drawing
{
    [XmlRoot("ph", Namespace = Constants.Presentation)]
    public class PlaceholderShape : XmlSerializable
    {
        [Optional]
        [XmlAttribute("type", Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_PlaceholderType> Type { get; set; }

        [Optional]
        [XmlAttribute("orient", Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_Direction> Direction { get; set; }

        [Optional]
        [XmlAttribute("sz", Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_PlaceholderSize> Size { get; set; }

        [Optional]
        [XmlAttribute("idx", Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> Index { get; set; }

        [Optional]
        [XmlAttribute("hasCustomPrompt", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> HasCustomPrompt { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Presentation)]
        public ExtensionList ExtensionList { get; set; }

        public PlaceholderShape() { }
    }
}
