﻿using DocumentFormat.OpenXml.Lite.Shared;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Presentation.SlideElements
{
    [XmlRoot("clrMapOvr", Namespace = Constants.Presentation)]
    public class ColorSchemeMapOverride : XmlSerializable
    {
        [Optional]
        [XmlElement("", Namespace = Constants.Graphic)]
        public IColorMapping Override { get; set; }

        public ColorSchemeMapOverride() { }
    }

    [XmlRoot("masterClrMapping", Namespace = Constants.Presentation)]
    public class MasterColorMapping : EmptyElement, IColorMapping
    {
        public MasterColorMapping() { }
    }

    [XmlRoot("overrideClrMapping", Namespace = Constants.Presentation)]
    public class OverrideColorMapping : ColorSchemeMap, IColorMapping
    {
        public OverrideColorMapping() { }
    }
}
