﻿using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Base;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Presentation.SlideElements
{
    [XmlRoot("hf", Namespace = Constants.Presentation)]
    public class HeaderFooterInfo : XmlSerializable
    {
        [Optional]
        [XmlAttribute("sldNum", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> SlideNumber { get; set; }

        [Optional]
        [XmlAttribute("hdr", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> Header { get; set; }

        [Optional]
        [XmlAttribute("ftr", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> Footer { get; set; }

        [Optional]
        [XmlAttribute("dt", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> DatTimt { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Presentation)]
        public ExtensionList ExtensionList { get; set; }

        public HeaderFooterInfo() { }
    }
}
