﻿using DocumentFormat.OpenXml.Lite.Core.Interfaces;
using DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Drawing
{
    [XmlRoot("twoCellAnchor", Namespace = Constants.Drawing)]
    public class TwoCellAnchor : XmlSerializable, ICellAnchor
    {
        [Optional]
        [XmlAttribute("editAs", Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_EditAs> EditAs { get; set; }

        [XmlElement("from", Namespace = Constants.Drawing)]
        public Point From { get; set; }

        [XmlElement("to", Namespace = Constants.Drawing)]
        public Point To { get; set; }

        [XmlElement("", Namespace = Constants.Drawing)]
        public IGraphicObject Graphic { get; set; }

        [XmlElement("clientData", Namespace = Constants.Drawing)]
        public ClientData ClientData { get; set; }

        public TwoCellAnchor() { }
    }
}
