﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.StyleElements
{
    [XmlRoot("borders", Namespace = Constants.ExcelMain)]
    public class Borders : XmlSerializable
    {
        [Optional]
        [XmlAttribute("count", Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> Count { get; set; }

        [Optional]
        [XmlElement("border", Namespace = Constants.ExcelMain)]
        public XmlList<Border> BorderList { get; set; }

        public Borders()
        {
            BorderList = new XmlList<Border>();
        }

        public uint AddBorder(Border border)
        {
            if (Count == null)
            {
                Count = 0;
            }

            Count++;
            BorderList.Add(border);
            return (uint)(Count - 1);
        }
    }
}
