﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.StyleElements
{
    [XmlRoot("cellXfs", Namespace = Constants.ExcelMain)]
    public class CellFormats : XmlSerializable
    {
        [Optional]
        [XmlAttribute("count", Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> Count { get; set; }

        [XmlElement("xf", Namespace = Constants.ExcelMain)]
        public XmlList<FormattingElement> FormattingElements { get; set; }

        public CellFormats()
        {
            FormattingElements = new XmlList<FormattingElement>();
        }

        public uint AddElement(FormattingElement element)
        {
            if (Count == null)
            {
                Count = 0;
            }

            Count++;
            FormattingElements.Add(element);
            return (uint)(Count - 1);
        }
    }
}
