﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.StyleElements
{
    [XmlRoot("fonts", Namespace = Constants.ExcelMain)]
    public class Fonts : XmlSerializable
    {
        [Optional]
        [XmlAttribute("count", Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> Count { get; set; }

        [Optional]
        [XmlElement("font", Namespace = Constants.ExcelMain)]
        public XmlList<Font> FontList { get; set; }

        public Fonts() 
        {
            FontList = new XmlList<Font>();
        }

        public uint AddFont(Font font)
        {
            if (Count == null)
            {
                Count = 0;
            }

            Count++;
            FontList.Add(font);
            return (uint)(Count - 1);
        }
    }
}
