﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.WorkbookElements
{
    [XmlRoot("sheet", Namespace = Constants.ExcelMain)]
    public class Sheet : XmlSerializable
    {
        [XmlAttribute("name")]
        public string Name { get; set; }

        [XmlAttribute("sheetId")]
        public uint Id { get; set; }

        [Optional]
        [XmlAttribute("state", Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_SheetState> State { get; set; }

        [XmlAttribute("id", Namespace = Constants.Relationship, Form = XmlSchemaForm.Qualified)]
        public string RelationshipId { get; set; }

        public Sheet() { }
    }
}
