﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML
{
    public class Constants
    {
        public const string Xml = "http://www.w3.org/XML/1998/namespace";
        public const string Graphic = "http://schemas.openxmlformats.org/drawingml/2006/main";
        public const string WordMain = "http://schemas.openxmlformats.org/wordprocessingml/2006/main";
        public const string Drawing = "http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing";
        public const string Relationship = "http://schemas.openxmlformats.org/officeDocument/2006/relationships";

        public static string GetDefaultPrefix(string ns)
        {
            switch (ns)
            {
                case Xml : return "xml";
                case Graphic: return "a";
                case Drawing: return "wp";
                case WordMain:  return "w";
                case Relationship: return "r";
                default: break;
            }
            return string.Empty;
        }
    }
}
