﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML.Word.SectionProperties
{
    [XmlRoot("docGrid", Namespace = Constants.WordMain)]
    public class DocumentGrid : XmlSerializable, ISectionPropElement
    {
        [Optional]
        [XmlAttribute("type", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_DocGrid> Type { get; set; }

        [Optional]
        [XmlAttribute("linePitch", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<int> LinePitch { get; set; }

        [Optional]
        [XmlAttribute("characterPitch", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<int> CharacterPitch { get; set; }

        public DocumentGrid() { }

        public void Copy(object obj)
        {
            if (obj is DocumentGrid)
            {
                this.Type = (obj as DocumentGrid).Type;
                this.LinePitch = (obj as DocumentGrid).LinePitch;
                this.CharacterPitch = (obj as DocumentGrid).CharacterPitch;
            }
        }
    }
}
