﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML.Word.SectionProperties
{
    [XmlRoot("paperSrc", Namespace = Constants.WordMain)]
    public class PaperSource : XmlSerializable, ISectionPropElement
    {
        [Optional]
        [XmlAttribute("first", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<int> First { get; set; }

        [Optional]
        [XmlAttribute("other", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<int> Other { get; set; }

        public PaperSource() { }

        public void Copy(object obj)
        {
            if (obj is PaperSource)
            {
                this.First = (obj as PaperSource).First;
                this.Other = (obj as PaperSource).Other;
            }
        }
    }
}
