﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Table.CellProperties
{
    [XmlRoot("tcW", Namespace = Constants.WordMain)]
    public class Width : XmlSerializable, ITableCellPropElement
    {
        [Optional]
        [XmlAttribute("w", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<int> Value { get; set; }

        [Optional]
        [XmlAttribute("type", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_TblWidth> Type { get; set; }

        public Width() { }

        public void Copy(object obj)
        {
            if (obj is Width)
            {
                this.Type = (obj as Width).Type;
                this.Value = (obj as Width).Value;
            }
        }
    }
}
