﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Table.RowProperties
{
    /// <summary>
    /// Table Row Cannot Break Across Pages
    /// </summary>
    [XmlRoot("trHeight", Namespace = Constants.WordMain)]
    public class Height : XmlSerializable, ITableRowPropElement
    {
        [Optional]
        [XmlAttribute("val", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> Value { get; set; }

        [Optional]
        [XmlAttribute("hRule", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_HeightRule> Type { get; set; }

        public Height() { }

        public void Copy(object obj)
        {
            if (obj is Height)
            {
                this.Type = (obj as Height).Type;
                this.Value = (obj as Height).Value;
            }
        }
    }
}
