﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Table.RowProperties
{
    [XmlRoot("wBefore", Namespace = Constants.WordMain)]
    public class WidthBefore : XmlSerializable, ITableRowPropElement
    {
        [Optional]
        [XmlAttribute("w", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<int> Width { get; set; }

        [Optional]
        [XmlAttribute("type", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_TblWidth> Type { get; set; }

        public WidthBefore() { }

        public void Copy(object obj)
        {
            if (obj is WidthBefore)
            {
                this.Type = (obj as WidthBefore).Type;
                this.Width = (obj as WidthBefore).Width;
            }
        }
    }
}
