﻿using DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties;
using DocumentFormat.OpenXml.Lite.DrawingML.Text;
using DocumentFormat.OpenXml.Lite.DrawingML.Text.Properties;
using DocumentFormat.OpenXml.Lite.Shared;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Chart
{
    [XmlRoot("dTable", Namespace = Constants.Chart)]
    public class DataTable : XmlSerializable
    {
        [Optional]
        [XmlElement("showHorzBorder", Namespace = Constants.Chart)]
        public NullableValue<bool> ShowHorizontalBorder { get; set; }

        [Optional]
        [XmlElement("showVertBorder", Namespace = Constants.Chart)]
        public NullableValue<bool> ShowVerticalBorder { get; set; }

        [Optional]
        [XmlElement("showOutline", Namespace = Constants.Chart)]
        public NullableValue<bool> ShowOutline { get; set; }

        [Optional]
        [XmlElement("showKeys", Namespace = Constants.Chart)]
        public NullableValue<bool> ShowKeys { get; set; }

        [Optional]
        [XmlElement("spPr", Namespace = Constants.Chart)]
        public ShapeProperties ShapeProperties { get; set; }

        [Optional]
        [XmlElement("txPr", Namespace = Constants.Chart)]
        public TextProperties TextProperties { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Chart)]
        public ExtensionList ExtensionList { get; set; }

        public DataTable() { }
    }
}
