﻿using DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties;
using DocumentFormat.OpenXml.Lite.Shared;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Chart.Elements
{
    [XmlRoot("dPt", Namespace = Constants.Chart)]
    public class DataPoint : XmlSerializable
    {
        [XmlElement("idx", Namespace = Constants.Chart)]
        public RequiredValue<uint> Index { get; set; }

        [Optional]
        [XmlElement("invertIfNegative", Namespace = Constants.Chart)]
        public NullableValue<bool> InvertIfNegative { get; set; }

        [Optional]
        [XmlElement("marker", Namespace = Constants.Chart)]
        public Marker Marker { get; set; }

        [Optional]
        [XmlElement("bubble3D", Namespace = Constants.Chart)]
        public NullableValue<bool> Bubble3d { get; set; }

        [Optional]
        [XmlElement("explosion", Namespace = Constants.Chart)]
        public RequiredValue<uint> Explosion { get; set; }

        [Optional]
        [XmlElement("spPr", Namespace = Constants.Chart)]
        public ShapeProperties Shapeproperties { get; set; }

        [Optional]
        [XmlElement("pictureOptions", Namespace = Constants.Chart)]
        public PictureOptions PictureOptions { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Chart)]
        public ExtensionList ExtensionList { get; set; }

        public DataPoint() { }
    }
}
