﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Chart
{
    [XmlRoot("extLst", Namespace = Constants.Chart)]
    public class ExtensionList : XmlSerializable
    {
        [Optional]
        [XmlElement("ext", Namespace = Constants.Chart)]
        public XmlList<Extension> Extensions { get; set; }

        public ExtensionList()
        {
            Extensions = new XmlList<Extension>();
        }
    }

    [XmlRoot("ext", Namespace = Constants.Chart)]
    public class Extension : XmlSerializable
    {
        [Optional]
        [XmlAttribute("uri", Form = XmlSchemaForm.Qualified)]
        public string URI { get; set; }

        public Extension() { }
    }
}
