﻿using DocumentFormat.OpenXml.Lite.DrawingML.Chart.Elements;
using DocumentFormat.OpenXml.Lite.DrawingML.Types;
using DocumentFormat.OpenXml.Lite.Shared;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Chart
{
    [XmlRoot("scatterChart", Namespace = Constants.Chart)]
    public class ScatterChart : XmlSerializable, IChartElement
    {
        [Optional]
        [XmlElement("scatterStyle", Namespace = Constants.Chart)]
        public NullableValue<ST_ScatterStyle> Style { get; set; }

        [Optional]
        [XmlElement("varyColors", Namespace = Constants.Chart)]
        public NullableValue<bool> VaryColors { get; set; }

        [Optional]
        [XmlElement("ser", Namespace = Constants.Chart)]
        public XmlList<ScatterSeries> Series { get; set; }

        [Optional]
        [XmlElement("dLbls", Namespace = Constants.Chart)]
        public DataLabels DataLabels { get; set; }

        [XmlElement("axId", Namespace = Constants.Chart)]
        public RequiredValue<uint> Axis1Id { get; set; }

        [XmlElement("axId", Namespace = Constants.Chart)]
        public RequiredValue<uint> Axis2Id { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Chart)]
        public ExtensionList ExtensionList { get; set; }

        public ScatterChart()
        {
            Series = new XmlList<ScatterSeries>();
        }
    }
}
