﻿using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Text;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Color
{
    [XmlRoot("clrScheme", Namespace = Constants.Main)]
    public class ColorScheme : XmlSerializable
    {
        [XmlAttribute("name", Form = XmlSchemaForm.Qualified)]
        public string Name { get; set; }

        [XmlElement("dk1", Namespace = Constants.Main)]
        public Color Dark1 { get; set; }

        [XmlElement("lt1", Namespace = Constants.Main)]
        public Color Light1 { get; set; }

        [XmlElement("dk2", Namespace = Constants.Main)]
        public Color Dark2 { get; set; }

        [XmlElement("lt2", Namespace = Constants.Main)]
        public Color Light2 { get; set; }

        [XmlElement("accent1", Namespace = Constants.Main)]
        public Color Accent1 { get; set; }

        [XmlElement("accent2", Namespace = Constants.Main)]
        public Color Accent2 { get; set; }

        [XmlElement("accent3", Namespace = Constants.Main)]
        public Color Accent3 { get; set; }

        [XmlElement("accent4", Namespace = Constants.Main)]
        public Color Accent4 { get; set; }

        [XmlElement("accent5", Namespace = Constants.Main)]
        public Color Accent5 { get; set; }

        [XmlElement("accent6", Namespace = Constants.Main)]
        public Color Accent6 { get; set; }

        [XmlElement("hlink", Namespace = Constants.Main)]
        public Color Hyperlink { get; set; }

        [XmlElement("folHlink", Namespace = Constants.Main)]
        public Color FollowedHyperlink { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public ColorScheme() { }
    }
}
