﻿using DocumentFormat.OpenXml.Lite.DrawingML.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Geometry
{
    [XmlRoot("grpSp", Namespace = Constants.Main)]
    public class GroupShape : XmlSerializable, IGroupShape
    {
        [XmlElement("nvGrpSpPr", Namespace = Constants.Main)]
        public NonVisualGroupShapeProperties NonVisualProperties { get; set; }

        [XmlElement("grpSpPr", Namespace = Constants.Main)]
        public GroupShapeProperties VisualProperties { get; set; }

        [Optional]
        [XmlElement("", Namespace = Constants.Main)]
        public XmlList<IGroupShape> Elements { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Main)]
        public ExtensionList ExtensionList { get; set; }

        public GroupShape()
        {
            Elements = new XmlList<IGroupShape>();
        }
    }
}
