﻿using DocumentFormat.OpenXml.Lite.DrawingML.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Geometry
{
    [XmlRoot("prstTxWarp", Namespace = Constants.Main)]
    public class PresetTextShape : XmlSerializable
    {
        [XmlAttribute("prst", Form = XmlSchemaForm.Qualified)]
        public ST_TextShapeType PresetWarpShape { get; set; }

        [Optional]
        [XmlElement("avLst", Namespace = Constants.Main)]
        public AdjustValueList AdjustValueList { get; set; }

        public PresetTextShape() { }
    }

    [XmlRoot("avLst", Namespace = Constants.Main)]
    public class AdjustValueList : XmlSerializable
    {
        [Optional]
        [XmlElement("gd", Namespace = Constants.Main)]
        public XmlList<ShapeGuide> ShapeGuides { get; set; }

        public AdjustValueList() { }
    }

    [XmlRoot("gd", Namespace = Constants.Main)]
    public class ShapeGuide : XmlSerializable
    {
        [XmlAttribute("name", Form = XmlSchemaForm.Qualified)]
        public string ShapeGuideName { get; set; }

        [XmlAttribute("fmla", Form = XmlSchemaForm.Qualified)]
        public string ShapeGuideFormula { get; set; }

        public ShapeGuide() { }
    }
}
