﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Style
{
    [XmlRoot("noAutofit", Namespace = Constants.Main)]
    public class NoAutofit : XmlSerializable, IAutoFit
    {
        public NoAutofit() { }
    }

    [XmlRoot("normAutofit", Namespace = Constants.Main)]
    public class NormalAutofit : XmlSerializable, IAutoFit
    {
        [Optional]
        [XmlAttribute("fontScale", Form = XmlSchemaForm.Qualified)]
        public Nullable<int> FontScale { get; set; }

        [Optional]
        [XmlAttribute("lnSpcReduction", Form = XmlSchemaForm.Qualified)]
        public Nullable<int> LineSpacereduction { get; set; }

        public NormalAutofit() { }
    }

    [XmlRoot("spAutofit", Namespace = Constants.Main)]
    public class ShapeAutofit : XmlSerializable, IAutoFit
    {
        public ShapeAutofit() { }
    }
}
