﻿using DocumentFormat.OpenXml.Lite.DrawingML.Geometry;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Transformation
{
    [XmlRoot("xfrm", Namespace = Constants.Main)]
    public class GroupTransform2d : XmlSerializable
    {
        [Optional]
        [XmlAttribute("rot", Form = XmlSchemaForm.Qualified)]
        public Nullable<int> Rotation { get; set; }

        [Optional]
        [XmlAttribute("flipH", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> HorizontalFlip { get; set; }

        [Optional]
        [XmlAttribute("flipV", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> VerticalFlip { get; set; }

        [Optional]
        [XmlElement("off", Namespace = Constants.Main)]
        public Offset Offset { get; set; }

        [Optional]
        [XmlElement("ext", Namespace = Constants.Main)]
        public Extent Extents { get; set; }

        [Optional]
        [XmlElement("chOff", Namespace = Constants.Main)]
        public Offset ChildOffset { get; set; }

        [Optional]
        [XmlElement("chExt", Namespace = Constants.Main)]
        public Extent ChildExtents { get; set; }

        public GroupTransform2d() { }
    }
}
