﻿using DocumentFormat.OpenXml.Lite.DrawingML.Chart;
using DocumentFormat.OpenXml.Lite.DrawingML.Types;
using DocumentFormat.OpenXml.Lite.Shared;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.DrawingML.Transformation
{
    [XmlRoot("scaling", Namespace = Constants.Chart)]
    public class Scaling : XmlSerializable
    {
        [Optional]
        [XmlElement("logBase", Namespace = Constants.Chart)]
        public RequiredValue<double> LogarithmicBase { get; set; }

        [Optional]
        [XmlElement("orientation", Namespace = Constants.Chart)]
        public NullableValue<ST_Orientation> Orientation { get; set; }

        [Optional]
        [XmlElement("max", Namespace = Constants.Chart)]
        public RequiredValue<double> Maximum { get; set; }

        [Optional]
        [XmlElement("min", Namespace = Constants.Chart)]
        public RequiredValue<double> Minimum { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Chart)]
        public ExtensionList ExtensionList { get; set; }

        public Scaling() { }
    }
}
