﻿using DocumentFormat.OpenXml.Lite.DrawingML;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Base;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.PresentationElements;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Drawing
{
    [XmlRoot("nvPr", Namespace = Constants.Presentation)]
    public class NonVisualProperties : XmlSerializable
    {
        [Optional]
        [XmlAttribute("isPhoto", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> IsPhoto { get; set; }

        [Optional]
        [XmlAttribute("userDrawn", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> UserDrawn { get; set; }

        [Optional]
        [XmlElement("ph", Namespace = Constants.Presentation)]
        public PlaceholderShape Placeholder { get; set; }

        [Optional]
        [XmlElement("", Namespace = Constants.Graphic)]
        public IMediaElement Media { get; set; }

        [Optional]
        [XmlElement("custDataLst", Namespace = Constants.Presentation)]
        public CustomerDataList CustomerDataList { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Presentation)]
        public ExtensionList ExtensionList { get; set; }

        public NonVisualProperties() { }
    }
}
