﻿using DMLT = DocumentFormat.OpenXml.Lite.DrawingML.Text;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties;
using DocumentFormat.OpenXml.Lite.DrawingML.Color;
using DocumentFormat.OpenXml.Lite.DrawingML.Text;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Drawing
{
    [XmlRoot("sp", Namespace = Constants.Presentation)]
    public class Shape : XmlSerializable, IShapeElement
    {
        [Optional]
        [XmlAttribute("useBgFill", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> UseBackfroundFill { get; set; }

        [XmlElement("nvSpPr", Namespace = Constants.Presentation)]
        public NonVisualShapeProperties NonVisualProperties { get; set; }

        [XmlElement("spPr", Namespace = Constants.Presentation)]
        public ShapeProperties Properties { get; set; }

        [Optional]
        [XmlElement("style", Namespace = Constants.Presentation)]
        public Style Style { get; set; }

        [Optional]
        [XmlElement("txBody", Namespace = Constants.Presentation)]
        public Body Body { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Presentation)]
        public ExtensionList ExtensionList { get; set; }

        public Shape() { }
    }
}
