﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Base;
using DocumentFormat.OpenXml.Lite.DrawingML.Geometry.Properties;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Drawing
{
    [XmlRoot("spTree", Namespace = Constants.Presentation)]
    public class ShapeTree : XmlSerializable
    {
        [XmlElement("nvGrpSpPr", Namespace = Constants.Presentation)]
        public NonVisualGroupShapeProperties NonVisualGroupShapeProperties { get; set; }

        [XmlElement("grpSpPr", Namespace = Constants.Presentation)]
        public GroupShapeProperties GroupShapeProperties { get; set; }

        [Optional]
        [XmlElement("", Namespace = Constants.Presentation)]
        public XmlList<IShapeElement> Shapes { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Presentation)]
        public ExtensionList ExtensionList { get; set; }

        public ShapeTree() 
        {
            Shapes = new XmlList<IShapeElement>();
        }
    }
}
