﻿using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Base;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Presentation.PresentationElements
{
    [XmlRoot("photoAlbum", Namespace = Constants.Presentation)]
    public class PhotoAlbum : XmlSerializable
    {
        [Optional]
        [XmlAttribute("bw", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> BlackAndWhite { get; set; }

        [Optional]
        [XmlAttribute("showCaptions", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> ShowCaptions { get; set; }

        [Optional]
        [XmlAttribute("layout", Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_PhotoAlbumLayout> Layout { get; set; }

        [Optional]
        [XmlAttribute("frame", Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_PhotoAlbumFrameShape> Frame { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Presentation)]
        public ExtensionList ExtensionList { get; set; }

        public PhotoAlbum() { }
    }
}
