﻿using DocumentFormat.OpenXml.Lite.PresentationML.Drawing;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.Base;
using DocumentFormat.OpenXml.Lite.PresentationML.Presentation.PresentationElements;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.PresentationML.Presentation.SlideElements
{
    [XmlRoot("cSld", Namespace = Constants.Presentation)]
    public class CommonSlideData : XmlSerializable
    {
        [Optional]
        [XmlAttribute("name", Form = XmlSchemaForm.Qualified)]
        public string Name { get; set; }

        [Optional]
        [XmlElement("bg", Namespace = Constants.Presentation)]
        public Background Background { get; set; }

        [XmlElement("spTree", Namespace = Constants.Presentation)]
        public ShapeTree ShapeTree { get; set; }

        [Optional]
        [XmlElement("custDataLst", Namespace = Constants.Presentation)]
        public CustomerDataList CustomerDataList { get; set; }

        [Optional]
        [XmlArray("controls", Namespace = Constants.Presentation)]
        [XmlArrayItem("control", Namespace = Constants.Presentation)]
        public XmlList<Control> Controls { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.Presentation)]
        public ExtensionList ExtensionList { get; set; }

        public CommonSlideData()
        {
            Controls = new XmlList<Control>();
        }
    }
}
