﻿using DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.WorksheetElements;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.StyleElements
{
    [XmlRoot("cellStyle", Namespace = Constants.ExcelMain)]
    public class CellStyle : XmlSerializable
    {
        [Optional]
        [XmlAttribute("name", Form = XmlSchemaForm.Qualified)]
        public string Name { get; set; }

        [Optional]
        [XmlAttribute("xfId", Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> FormatId { get; set; }

        [Optional]
        [XmlAttribute("builtinId", Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> BuiltinId { get; set; }

        [Optional]
        [XmlAttribute("iLevel", Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> OutlineStyle { get; set; }

        [Optional]
        [XmlAttribute("hidden", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> Hidden { get; set; }

        [Optional]
        [XmlAttribute("customBuiltin", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> CustomBuiltin { get; set; }

        [Optional]
        [XmlElement("extLst", Namespace = Constants.ExcelMain)]
        public ExtensionList ExtensionList { get; set; }

        public CellStyle() { }
    }
}
