﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.StyleElements
{
    [XmlRoot("cellStyles", Namespace = Constants.ExcelMain)]
    public class CellStyles : XmlSerializable
    {
        [Optional]
        [XmlAttribute("count", Form = XmlSchemaForm.Qualified)]
        public Nullable<uint> Count { get; set; }

        [Optional]
        [XmlElement("cellStyle", Namespace = Constants.ExcelMain)]
        public XmlList<CellStyle> CellStyleList { get; set; }

        public CellStyles()
        {
            CellStyleList = new XmlList<CellStyle>();
        }

        public void AddBorder(CellStyle style)
        {
            if (Count == null)
            {
                Count = 0;
            }

            Count++;
            CellStyleList.Add(style);
        }
    }
}
