﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.Table
{
    [XmlRoot("tableStyleInfo", Namespace = Constants.ExcelMain)]
    public class TableStyleInfo : XmlSerializable
    {
        [Optional]
        [XmlAttribute("name", Form = XmlSchemaForm.Qualified)]
        public string Name { get; set; }

        [Optional]
        [XmlAttribute("showFirstColumn", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> ShowFirstColumn { get; set; }

        [Optional]
        [XmlAttribute("showLastColumn", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> ShowLastColumn { get; set; }

        [Optional]
        [XmlAttribute("showRowStripes", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> ShowRowStripes { get; set; }

        [Optional]
        [XmlAttribute("showColumnStripes", Form = XmlSchemaForm.Qualified)]
        public Nullable<bool> ShowColumnStripes { get; set; }

        public TableStyleInfo() { }
    }
}
