﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.SpreadsheetML.Excel.WorksheetElements
{
    [XmlRoot("extLst", Namespace = Constants.ExcelMain)]
    public class ExtensionList : XmlSerializable
    {
        [XmlElement("ext")]
        public XmlList<Extension> Extensions { get; set; }

        public ExtensionList() 
        {
            Extensions = new XmlList<Extension>();
        }
    }

    [XmlRoot("ext", Namespace = Constants.ExcelMain)]
    public class Extension : XmlSerializable
    {
        [XmlAttribute("uri")]
        public string URI { get; set; }

        [Optional]
        [XmlElement]
        public object Element { get; set; }

        public Extension() { }
    }
}
