﻿using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML.Word.RunProperties
{
    /// <summary>
    /// Vertically raised or lowered text
    /// </summary>
    [XmlRoot("position", Namespace = Constants.WordMain)]
    public class RaisedText : XmlSerializable, IRunPropElement
    {
        [XmlAttribute("val", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public uint Measure { get; set; }

        public RaisedText() { }

        public void Copy(object obj)
        {
            if (obj is RaisedText)
            {
                this.Measure = (obj as RaisedText).Measure;
            }
        }
    }
}
