﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML.Word.SectionProperties
{
    /// <summary>
    /// Only Allow Editing of Form Fields
    /// </summary>
    [XmlRoot("formProt", Namespace = Constants.WordMain)]
    public class FormProt : XmlSerializable, ISectionPropElement
    {
        [Optional]
        [XmlAttribute("val", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_OnOff> Value { get; set; }

        public FormProt() { }

        public void Copy(object obj)
        {
            if (obj is FormProt)
            {
                this.Value = (obj as FormProt).Value;
            }
        }
    }
}
