﻿using DocumentFormat.OpenXml.Lite.Helper;
using DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Types;
using DocumentFormat.OpenXml.Lite.Xml;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;

namespace DocumentFormat.OpenXml.Lite.WordprocessingML.Word.Table.RowProperties
{
    /// <summary>
    /// Table Row Cannot Break Across Pages
    /// </summary>
    [XmlRoot("cantSplit", Namespace = Constants.WordMain)]
    public class CantSplit : XmlSerializable, ITableRowPropElement
    {
        [Optional]
        [XmlAttribute("val", Namespace = Constants.WordMain, Form = XmlSchemaForm.Qualified)]
        public Nullable<ST_OnOff> Value { get; set; }

        public CantSplit() { }

        public void Copy(object obj)
        {
            if (obj is CantSplit)
            {
                this.Value = (obj as CantSplit).Value;
            }
        }
    }
}
